производитель деревянных окон со стеклопакетом
| Правила | Регистрация | Пользователи | Поиск | Сообщения за день | Все разделы прочитаны |  Справка по форуму | Файлообменник |

Вернуться   Форум DWG.RU > Программное обеспечение > Программирование > LISP > Lisp. Определить угол поворота ПСК относительно МСК

Lisp. Определить угол поворота ПСК относительно МСК

Ответ
Поиск в этой теме
Непрочитано 11.04.2013, 15:40 #1
Lisp. Определить угол поворота ПСК относительно МСК
sdv79
 
Инженер ЭОМ
 
Москва
Регистрация: 05.03.2009
Сообщений: 215

Необходимо динблок через дан.свойство повернуть. В МСК это 0 или 90. Хочу узнать угол поворота ПСК, и сделать приращение.
Код:
[Выделить все]
 
   (vlax-put-property ; правильно поварачиваем
     (nth 0 ; 0 отвечает за угол поворота
      (safearray-value(vlax-variant-value ; дешефратор
       (vla-GetDynamicBlockProperties
        (vlax-ename->vla-object
         (entlast)
        ) ;/ vlax-ename->vla-object
       ) ;/ vla-GetDynamicBlockProperties
      )) ;/ safearray-value
     ) ;/ nth
     (function value)
     corner
;;;      (if(>= side_X side_Y) ; = привычней для квадрата ориентация по горизонтали
;;; ;|1|; 0.0
;;; ;|2|; corner ; 1.5708 ; угол в радианах
;;;      ) ;/ if
    ) ;/ vlax-put-property
Просмотров: 1731
 
Непрочитано 11.04.2013, 16:19
#2
Kirill_Ja


 
Регистрация: 28.07.2008
Мурманск
Сообщений: 208
<phrase 1=


Тебе читать тут и еще можно тут если шаришь в геометрии
Kirill_Ja вне форума  
 
Автор темы   Непрочитано 11.04.2013, 18:53
#3
sdv79

Инженер ЭОМ
 
Регистрация: 05.03.2009
Москва
Сообщений: 215
Отправить сообщение для sdv79 с помощью Skype™


Kirill_Ja спасибо, но не то. Везде используют именную ПСК, к ней еще есть доступ. В моем же случае, пользователь просто поворачивает СК вдоль помещения, расставляет светильники и обратно в МСК.
Код:
[Выделить все]
 
(tblnext "UCS") ; nil
(vla-get-activeUCS(vla-get-activedocument(vlax-get-acad-object))) ; говорит об ошибке
(vla-get-UserCoordinateSystems(vla-get-activedocument(vlax-get-acad-object))) ; тупиковая ветка развития
ПОБЕДА, нашел простое решение

Код:
[Выделить все]
 
(angtos 
 (angle
  (list 0.0 0.0 1.0) 
  (getvar "UCSXDIR")
 )
)
PS: обновил программу mySchema, с учетом этих изменений...

Последний раз редактировалось sdv79, 11.04.2013 в 19:22.
sdv79 вне форума  
Ответ
Вернуться   Форум DWG.RU > Программное обеспечение > Программирование > LISP > Lisp. Определить угол поворота ПСК относительно МСК

Система Техэксперт дает уверенность в правильности и эффективности принимаемых инженерных решений!
Размещение рекламы
Опции темы Поиск в этой теме
Поиск в этой теме:

Расширенный поиск


Похожие темы
Тема Автор Раздел Ответов Последнее сообщение
Создание нового типа линий Apelsinov AutoCAD 912 11.07.2020 21:24
VBA. 3D. Ориентация блоков (примитивов) в пространстве? Как определить угол поворота? shumilovvv Программирование 2 15.05.2009 12:18
Как определить угол наклона примитива Ratmir Программирование 2 24.03.2009 06:23
LISP. Как определить вставку блока с xclip? Apelsinov LISP 4 18.02.2009 14:03
Угол поворота Viewport plaz AutoCAD 15 05.12.2006 02:27